Bug 1004337 - Review Request: python3-docs - Documentation for the Python 3 programming language
Review Request: python3-docs - Documentation for the Python 3 programming lan...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Simon A. Erat
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 984018
  Show dependency treegraph
 
Reported: 2013-09-04 08:47 EDT by Bohuslav "Slavek" Kabrda
Modified: 2013-11-10 02:58 EST (History)
3 users (show)

See Also:
Fixed In Version: python3-docs-3.3.2-2.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-10 02:58:23 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
besser82: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Bohuslav "Slavek" Kabrda 2013-09-04 08:47:26 EDT
Spec URL: http://bkabrda.fedorapeople.org/pkgs/python3-docs/python3-docs.spec
SRPM URL: http://bkabrda.fedorapeople.org/pkgs/python3-docs/python3-docs-3.3.2-1.fc19.src.rpm
Description:
The python3-docs package contains documentation on the Python 3 programming language and interpreter.
Install the python3-docs package if you'd like to use the documentation for the Python 3 language.
Fedora Account System Username: bkabrda
Comment 1 Simon A. Erat 2013-09-06 08:26:07 EDT
Informal Review - failed
-------------------------

Spec  not 'clear'
--------

Use the %{name} makro instead of self created ${python}.
Within the spec, and the source, Python is written in small and capital letters, both ways.
> Fix naming issues.

%build - looks quite empty, is that enough?
> %install - no files to move/cp?


You want to make a documention package of python 3 only.
Why dont you download the docs-tarball from python?
>http://docs.python.org/3/download.html
>Further its 3.2.2, not the latest package 3.4.0.


Fix this and try again.
Comment 2 Björn "besser82" Esser 2013-09-06 08:46:29 EDT
FTBFS on rawhide!  Excerpt from build.log:

  (%build): /bin/sh -e /var/tmp/rpm-tmp.Dn6X33
  + umask 022
  + cd /builddir/build/BUILD
  + cd Python-3.3.2
  + make -C Doc html
  make: Entering directory `/builddir/build/BUILD/Python-3.3.2/Doc'
  Checking out Sphinx...
  /bin/sh: line 2: svn: command not found
  make: Leaving directory `/builddir/build/BUILD/Python-3.3.2/Doc'
  make: *** [checkout] Error 127
Comment 3 Björn "besser82" Esser 2013-09-06 08:59:52 EDT
Thoughts on spec-file:

  * You can strip a lot of the "macro-madness", which has 0-impact on the
    actual result.

  * There is an easy way of getting the needed python-version:
  %global pyver %(v=`python3 --version 2>&1 | sed -e"s/.ython[ \t]*//"`;echo $v)
    which is better than hardcoding it ;)
Comment 4 Bohuslav "Slavek" Kabrda 2013-09-06 09:18:10 EDT
Thanks for your comments, guys:
- As for the %{python} macro, where in the specfile do I use it in an inappropriate place?
- The "macro madness" is there because when the package goes through the review, I want it to have minimal diff with "python-docs" package (which this package is based on, BTW). So each spec will hardcode the python version, but each will be different.
- %build - yes, I just create documentation and remove the .buildinfo dir, nothing else needed
- If I'm referring to the same docs as you, they are already generated and can't be regeneraged. I consider that bad, everything should be built from source, IMO, even just documentation.
- As for the Koji failure, that's interesting... I didn't experience it in my local mock, but I admit I didn't scrub it before building. I'll investigate and repost the spec and srpm once I find the problem.
Comment 5 Björn "besser82" Esser 2013-09-06 09:36:15 EDT
(In reply to Bohuslav "Slavek" Kabrda from comment #4)
> Thanks for your comments, guys:
> - As for the %{python} macro, where in the specfile do I use it in an
> inappropriate place?

Actually nowhere, it was just about that "macro-medness", I think. :)


> - The "macro madness" is there because when the package goes through the
> review, I want it to have minimal diff with "python-docs" package (which
> this package is based on, BTW). So each spec will hardcode the python
> version, but each will be different.

Why do you want to keep the diff as small as possible?  Is there any not foreseeable reason in it?

btw. Why don't you just generate && pkg the docs during build of "regular" python3-pkg?  Afaik, you are the maintainer of it, too.

> - If I'm referring to the same docs as you, they are already generated and
> can't be regeneraged. I consider that bad, everything should be built from
> source, IMO, even just documentation.

Just explained that to Simon in 1:1 irc.  ;)

> - As for the Koji failure, that's interesting... I didn't experience it in
> my local mock, but I admit I didn't scrub it before building. I'll
> investigate and repost the spec and srpm once I find the problem.

It seems there is something on the make file, which tries to do some SVN-checkout...
Comment 6 Bohuslav "Slavek" Kabrda 2013-09-16 09:04:00 EDT
(In reply to Björn "besser82" Esser from comment #5)
> (In reply to Bohuslav "Slavek" Kabrda from comment #4)
> > - The "macro madness" is there because when the package goes through the
> > review, I want it to have minimal diff with "python-docs" package (which
> > this package is based on, BTW). So each spec will hardcode the python
> > version, but each will be different.
> 
> Why do you want to keep the diff as small as possible?  Is there any not
> foreseeable reason in it?
> 

- Tracking difference between the two specfiles
- Applying dist-git patches from one repo to the other

Generally, python and python3 are trying to follow this, but they're build process is too different to achieve good similarity. With python{,3}-docs, it is however much easier.

> btw. Why don't you just generate && pkg the docs during build of "regular"
> python3-pkg?  Afaik, you are the maintainer of it, too.
> 

Yes. I was surprised by this at first, when I became maintainer of python and python-docs, but the build with linkchecker tests active would make the already-long-enough python build even longer, so it is more comfortable for me as a maintainer. Is this a big problem from your POV?

> > - As for the Koji failure, that's interesting... I didn't experience it in
> > my local mock, but I admit I didn't scrub it before building. I'll
> > investigate and repost the spec and srpm once I find the problem.
> 
> It seems there is something on the make file, which tries to do some
> SVN-checkout...

Ah, yes, I patched that out, should be working now. Posting new specfile and srpm:

SPEC: http://bkabrda.fedorapeople.org/pkgs/python3-docs/python3-docs.spec
SRPM: http://bkabrda.fedorapeople.org/pkgs/python3-docs/python3-docs-3.3.2-2.fc19.src.rpm
Comment 7 Bohuslav "Slavek" Kabrda 2013-09-25 06:08:40 EDT
Ping reviewer... can we proceed? Thanks.
Comment 8 Simon A. Erat 2013-10-14 05:54:05 EDT
Informal Review (NOT final):
================
- Add html/license.html to %doc


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package contains BR: python2-devel or python3-devel


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "GPL (v2 or later)", "GPL (v3 or later)", "Unknown or
     generated", "MIT/X11 (BSD like)", "zlib/libpng", "BSD (3 clause)", "BSD
     (2 clause)", "*No copyright* Public domain", "MPL (v1.1) GPL
     (unversioned/unknown version)". 2207 files have unknown license. Detailed
     output of licensecheck in
     /home/simon/1004337-python3-docs/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[?]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
     Note: Test run failed
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Test run failed
[x]: Packages must not store files under /srv, /opt or /usr/local
     Note: Test run failed
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.

Python:
[-]: Binary eggs must be removed in %prep
     Note: Test run failed
[-]: Python eggs must not download any dependencies during the build process.
     Note: Test run failed
[-]: A package which is used by another package via an egg interface should
     provide egg info.
     Note: Test run failed
[x]: Package meets the Packaging Guidelines::Python
     Note: Test run failed

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[-]: Latest version is packaged.
[-]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define pybasever 3.3
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[-]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Test run failed
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-docs-3.3.2-2.fc21.noarch.rpm
          python3-docs-3.3.2-2.fc21.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python3-docs
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
python3-docs (rpmlib, GLIBC filtered):
    python3



Provides
--------
python3-docs:
    python3-docs



Source checksums
----------------
http://www.python.org/ftp/python/3.3.2/Python-3.3.2.tar.xz :
  CHECKSUM(SHA256) this package     : 745b32c4b810e36fa66346198dbc2e313524fd68888922b85005656825e64b43
  CHECKSUM(SHA256) upstream package : 745b32c4b810e36fa66346198dbc2e313524fd68888922b85005656825e64b43


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/bin/fedora-review -m fedora-rawhide-i386 -b 1004337
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Python, Shell-api
Disabled plugins: Java, C/C++, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 9 Björn "besser82" Esser 2013-10-20 02:51:40 EDT
(In reply to Simon A. Erat from comment #8)
> Informal Review (NOT final):
> ================
> - Add html/license.html to %doc

    ---> This is already picked up by globbing the whole
         `Doc/build/html`-dir.  No issues here.  :)

> Issues:
> =======
> - Package contains BR: python2-devel or python3-devel

    ---> Package uses `python3-devel`, but it's somehow obfuscated by using
         macros.  No issues here.  :)

> ===== MUST items =====
> 
> Generic:
> [?]: Package obeys FHS, except libexecdir and /usr/target.

       ---> Package obeys FHS.  No issues here.  :)

> ===== SHOULD items =====
> 
> Generic:
> [!]: Uses parallel make %{?_smp_mflags} macro.

       ---> This is intentional on python*-doc generated by pythonX-sphinx.
            sphinx runs threaded internally.  No issues here.  :)


This package can safely get approved by you, Simon.
Comment 10 Simon A. Erat 2013-10-20 08:30:57 EDT
APPOVED
Comment 11 Bohuslav "Slavek" Kabrda 2013-10-21 02:29:20 EDT
New Package SCM Request
=======================
Package Name: python3-docs
Short Description: Documentation for the Python 3 programming language
Owners: bkabrda
Branches: f20
InitialCC:
Comment 12 Björn "besser82" Esser 2013-10-22 07:21:10 EDT
Bushuslav, you somehow messed up the flags of this bug.  I just fixed this.
Comment 13 Gwyn Ciesla 2013-10-22 07:45:42 EDT
Git done (by process-git-requests).
Comment 14 Bohuslav "Slavek" Kabrda 2013-10-22 07:59:10 EDT
(In reply to Björn "besser82" Esser from comment #12)
> Bushuslav, you somehow messed up the flags of this bug.  I just fixed this.

Oh, you're right. Thanks for fixing!
Comment 15 Fedora Update System 2013-10-22 08:28:28 EDT
python3-docs-3.3.2-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/python3-docs-3.3.2-2.fc20
Comment 16 Fedora Update System 2013-10-22 14:51:45 EDT
python3-docs-3.3.2-2.fc20 has been pushed to the Fedora 20 testing repository.
Comment 17 Fedora Update System 2013-11-10 02:58:23 EST
python3-docs-3.3.2-2.fc20 has been pushed to the Fedora 20 stable repository.

Note You need to log in before you can comment on or make changes to this bug.